unit DateTimeUtils;

interface

uses Controls, Sysutils;

type
  TDateAddPart = (Year, Month, Week, Day);

function DateAdd(DatePart: TDateAddPart; AddNumber: Integer; CurrentDate: TDate): TDate;

implementation

function DateAdd(DatePart: TDateAddPart; AddNumber: Integer; CurrentDate: TDate): TDate;
var
  iYear, iMonth, iDay: Word;
  iToAddDays, iMonthDays: Integer;
begin
  iMonthDays := 0;
  Result := CurrentDate;
  if AddNumber = 0 then Exit;
  case DatePart of
    Year:
      begin
        DecodeDate(CurrentDate, iYear, iMonth, iDay);
        iYear := iYear + AddNumber;
        Result := EncodeDate(iYear, iMonth, iDay);
      end;
    Month: Result := IncMonth(CurrentDate, AddNumber);
    Week: Result := DateAdd(Day, AddNumber * 7, CurrentDate);
    Day:
      begin
        iToAddDays := AddNumber;
        DecodeDate(CurrentDate, iYear, iMonth, iDay);
        if iToAddDays > 0 then
          while iToAddDays > 0 do
          begin
            case iMonth of
              1, 3, 5, 7, 9, 11: iMonthDays := 31;
              4, 6, 8, 10, 12: iMonthDays := 30;
              2:
                begin
                  if IsLeapYear(iYear) then
                    iMonthDays := 29
                  else
                    iMonthDays := 28;
                end;
            end;  // end case iMonth of
            if iMonthDays >= (iToAddDays + iDay) then
            begin
              iDay := iDay + iToAddDays;
              iToAddDays := 0;
            end
            else  // goto next month
            begin
              if iMonth = 12 then
              begin
                iMonth := 1;
                Inc(iYear);
              end
              else
                Inc(iMonth);
              iToAddDays := iToAddDays - (iMonthDays - iDay);
              iDay := 0;
            end;
          end  // end while iToAddDays > 0
        else
          while iToAddDays < 0 do
          begin
            if iDay > -iToAddDays then
            begin
              iDay := iDay + iToAddDays;
              iToAddDays := 0;
            end
            else  // goto previous month
            begin
              if iMonth = 1 then
              begin
                iMonth := 12;
                Dec(iYear);
              end
              else
              begin
                Dec(iMonth);
                case iMonth of
                  1, 3, 5, 7, 9, 11: iMonthDays := 31;
                  4, 6, 8, 10, 12: iMonthDays := 30;
                  2:
                    begin
                      if IsLeapYear(iYear) then
                        iMonthDays := 29
                      else
                        iMonthDays := 28;
                    end;
                end;  // end case iMonth of
                iToAddDays := iToAddDays + iDay;
                iDay := iMonthDays;
              end;
            end;
          end; //  end while iToAddDays < 0
        Result := EncodeDate(iYear, iMonth, iDay);
      end;
  end;
end;

end.
