function Smaller(const a, b: longint): longint;
begin
  if (a < b) then
  begin
    Result := a;
  end 
  else if (b > 0) then
  begin
    Result := b
  end 
  else 
    Result := 0;
end;
    
function SplitFile(FFileName: AnsiString; SplitSize: longint): boolean;
var
  InFile: TFileStream;
  OutFile: TFileStream;
  FilePlace: integer;
  INI: TIniFile;
  FileInfo: TFinfo;
begin
  InFile := TFileStream.Create(FFileName, fmOpenRead);
  if InFile.Size > SplitSize then
  begin
    FilePlace := 0;
    while InFile.Position < InFile.Size do 
    begin
      Inc(FilePlace);
      OutFile := TFileStream.Create(FFileName + '.' + FormatFloat('000', FilePlace),
        fmCreate);
      OutFile.CopyFrom(InFile, Smaller(SplitSize, InFile.Size - InFile.Position));
      OutFile.Free;
    end;
  end 
  else 
    ShowMessage('The File Is To Small To Split');
  InFile.Free;
  INI := TIniFile.Create(ChangeFileExt(FFileName, '.rtr'));
  INI.WriteString('Files', 'Number', IntToStr(FilePlace));
  INI.WriteString('Files', 'Name', FFileName);
  INI.Free;
  Result := True;
end;
    
function UnSplit(FFileName: TFileName; BufferSize: longint): boolean;
var
  INI: TIniFile;
  InFile: TFileStream;
  OutFile: TFileStream;
  FilePlace: integer;
  NFiles: integer;
  FFile: TFileName;
  BytesRead: longint;
  Buffer: Pointer;
  FString: TFileName;
begin
  GetMem(Buffer, BufferSize);
  INI := TIniFile.Create(FFileName);
  NFiles := StrToInt(INI.ReadString('Files', 'Number', '0'));
  FFile := INI.ReadString('Files', 'Name', '0');
  OutFile := TFileStream.Create(FFile, fmCreate);
  FilePlace := 1;
  while FilePlace <= NFiles do
  begin
    FString := (FFile + '.' + FormatFloat('000', FilePlace));
    InFile := TFileStream.Create(FString, fmOpenRead);
    while InFile.Size <> InFile.Position do
    begin
      Inc(FilePlace);
      BytesRead := InFile.Read(Buffer^, BufferSize);
      OutFile.Write(Buffer^, BytesRead);
    end;
    InFile.Free;
  end;
  Result := True;
  OutFile.Free;
end;
    {
    Also Two Sample Calls:
    SplitFile('C:\afilename.exe',40000);
    UnSplit('C:\samefilenameasabovewith-rtr-extension.rtr',40000);
    }
