procedure AddDisableBMP(SB: TSpeedButton);
var BM, SBM: TBitmap;
    w, x, y, NewColor: Integer;
    PixelColor: TColor;
begin
  if not Assigned(SB.Glyph) or (SB.Glyph.Width <> SB.Glyph.Height) then Exit;
  BM := TBitmap.Create;
  BM.Transparent := True;
  SBM := TBitmap.Create;
  try
    BM.Assign(SB.Glyph);

    w := SB.Glyph.Width;
    SBM.Width := w * 2;
    SBM.Height := w;
    SBM.Canvas.Draw(0, 0, BM);

      for x := 0 to w - 1 do
        for y := 0 to w - 1 do
        begin
          PixelColor := ColorToRGB(BM.Canvas.Pixels[x, y]);
          NewColor := Round((((PixelColor shr 16) + ((PixelColor shr 8) and $00FF) +
                       (PixelColor and $0000FF)) div 3)) div 2 + 96;
          BM.Canvas.Pixels[x, y] := RGB(NewColor, NewColor, NewColor);
        end;


    SBM.Canvas.Draw(w, 0, BM);
    SB.Glyph.Assign(SBM);
    SB.NumGlyphs := 2;
  finally
    BM.Free;
    SBM.Free;
  end;
end;
