  procedure Icon2Bitmap(const Icon: TIcon; Bitmap: TBitmap);
  var TempBitmap: TBitmap;
      IconInfo: TIconInfo;
  begin
    // Retrieve icon data
    if (not GetIconInfo(Icon.Handle, IconInfo)) then Exit;
    TempBitmap := TBitmap.Create;
    try
      // Borrow the icon bitmap handle and assign it to a TBitmap
      TempBitmap.Handle := IconInfo.hbmColor;
      try
        // Copy bitmap
        Bitmap.Assign(TempBitmap);
        // Force copy to clone handle
        Bitmap.Handle;
      finally
        // Give the bitmap handle back to the icon
        TempBitmap.ReleaseHandle;
      end;
    finally
      TempBitmap.Free;
    end;
  end;

