{Purpose: Wouldn't be nice to place the Windows desktop into a TImage
component on a Delphi form? Let's see how can we do this?
Description: first at all, we will place a TTimer on our form, and set its interval=50. In the OnTimer event we will check if 
the F12 key was pressed, if yes, we will call the GetScreen function:}

procedure TfMain.Timer1Timer(Sender: TObject);
var bmp:TBitmap;
begin
try
if (GetAsyncKeyState(VK_F12) and 1=1) then begin
bmp:=GetScreen;
img.picture.bitmap.assign(bmp);
bmp.free;
end;
except
end;
end;

{This function will return a TBitmap structure, containing the currently visible image from the windows desktop. This way, the desktop will be
captured, even if our application is minimized. Now let's see the hart of this trick, the GetScreen function: }

function TfMain.GetScreen:TBitmap;
var DC : HDC;
bmp:TBitmap;
begin
DC:=GetDC (GetDesktopWindow);
bmp:=TBitmap.Create;
try
bmp.Width := GetDeviceCaps (DC, HORZRES);
bmp.Height := GetDeviceCaps (DC, VERTRES);
BitBlt(bmp.Canvas.Handle, 0, 0, bmp.Width,bmp.Height,DC, 0, 0, SRCCOPY);
finally
ReleaseDC(GetDesktopWindow, DC);
end;
Result:=bmp;
end;

{The function which will capture and transfer the image of the desktop, is the BitBlt API function. This function performs a bit-block transfer
of the color data corresponding to a rectangle of pixels from the specified source device context into a destination device context. So, all we 
have to do, is to provide the device context of our desktop, as source device context for the BitBlt function. For this we will use the GetDC 
API call, with the GetDesktopWindow parameter. This function will return the device context of our windows desktop. As source device 
context we specify the Handle of our TBitmap variable: bmp.Canvas.Handle. This way the BitBlt function will draw on the canvas of bmp 
variable at coordinates 0,0, the image of the windos destop, starting with coordinates 0,0. To receive the width and height of our windows 
desktop, we'll use the GetDeviceCaps API call with HORZRES (for width) and VERTRES (for height) paramaters. 
Don't forget to finally release the windows desktop!}

