{
  This unit was generated on Wed,  1 Oct 2003 14:33:33 +0100
  by the code snippets database at www.delphidabbler.com.
  Check the site for updates.

  Copyright (c) Peter Johnson (DelphiDabbler), 2003.
  The unit may be freely distributed.
}

unit DDSnippets;

interface

uses
  Windows, SysUtils, Classes, ShellAPI, IniFiles, UrlMon, ShlObj, ActiveX, Registry;

function WinFileTimeToDateTime(FT: Windows.TFileTime): TDateTime;
  {Converts Windows FILETIME to Delphi TDateTime. Raises exception if file time
  is not a valid value.}

function WinFileTimeToDOSFileTime(FT: Windows.TFileTime): Integer;
  {Converts a Windows FILETIME to a DOS file time. Raises exception if file time
  is not a valid value.}

function WinFileTimeToStr(FT: Windows.TFileTime): string;
  {Converts a Windows FILETIME structure to a string. Raises exception if file
  time is not a valid value.}

procedure CopyFile(const Source, Dest: string);
  {Copies Source file to Dest, preserving modification date.}

procedure CreateURLShortcut(const ShortcutFile, URL: string);
  {Creates a URL shortcut file with the given name for the given URL,
  overwriting any existing file. An exception is raised if file can't be
  created.}

function DeleteFileWithUndo(const FileName: string): Boolean;
  {Deletes given file and sends it to recycle bin. Returns true if file deleted
  successfully.}

function DirToPath(const Dir: string): string;
  {Return given directory with a trailing '\'.}

function DOSToUnixPath(const PathName: string): string;
  {Converts a DOS path to a Unix path and returns it.}

function DriveTypeFromPath(const Path: string): LongWord;
  {Returns type of drive that contains the given (full) path.}

function GetFileDate(const FName: string): Integer;
  {Returns modification date of given file encoded as integer.}

function GetFixedFileVerInfo(const FileName: string;
  out FFI: Windows.TVSFixedFileInfo): Boolean;
  {Extracts fixed version information from a file. If file contains version
  information it is returned via FFI parameter and function returns true,
  otherwise false is returned and FFI is undefined.}

function HasVerInfo(const FileName: string): Boolean;
  {Returns true if the given file contains version information and false if
  not.}

function IsDirectory(const DirName: string): Boolean;
  {Returns true if given name is a valid directory and false otherwise. DirName
  can be any file system name (with or without trailing path delimiter).}

procedure SetFileDate(const FName: string; const ADate: Integer);
  {Sets modification date of given file to given integer coded value.}

function ShortToLongPath(const FilePath: string): string;
  {Converts whole of given DOS style 8.3 path to long file path and returns it.
  If path can't be converted then '' is returned.}

function TempFileName(const Stub: string; const Create: Boolean): string;
  {Returns a unique temporary file name in temporary folder. File name includes
  first three characters of Stub followed by hexadecimal characters. If Create
  is true file is created. Returns empty string on failure.}

function Touch(const FileName: string): Boolean;
  {Sets modification date of given file to current date and time. Returns true
  if date set successfully or false on error.}

function URLFromShortcut(const Shortcut: string): string;
  {Returns the URL referenced by the given URL shortcut file, or the empty
  string if the given file is not a shortcut file.}

function BrowseURL(const URL: string): Boolean;
  {Activates default browser or email client for given URL. Returns true if
  browser/email client is uccessfully launched and false if not. Raises
  exception if URL doesn't conform to a known valid protocol.}

function DownloadURLToFile(const URL, FileName: string): Boolean;
  {Downloads file at URL and stores in given file. Returns true if download
  succeeds and false on failure. A connection to the internet must be open for
  download to succeed.}

function IsValidURLProtocol(const URL: string): Boolean;
  {Checks if the given URL is valid per RFC1738. Returns true is valid and false
  if not.}

function MakeSafeHTMLText(TheText: string): string;
  {Replaces any characters in the given text that are HTML-compatible with
  suitable escaped versions and returns modified string.}

function URLDecode(const S: string): string;
  {Decodes the given encoded URL or URL query string. Raises exception if the
  encoded URL is badly formed.}

function URLEncode(const S: string): string;
  {URL encodes the given string, making it suitable for passing as part of a URL
  query.}

function CompressWhiteSpace(const S: string): string;
  {Returns a copy of given string with all white space characters replaced by
  space characters and all sequences of white space replaced by a single space
  character.}

function CountDelims(const S, Delims: string): Integer;
  {Returns count of all occurences of any of the given delimiter characters in
  the string S.}

function ExplodeStr(S: string; const Delim: Char; const List: Classes.TStrings;
  const AllowEmpty: Boolean = True): Integer;
  {Splits the string S into a list of strings, separated by Delim, and returns
  the number of strings in the list. If AllowEmpty is true then any empty
  strings are added to the list, while they are ignored if AllowEmpty is
  false.}

function JoinStr(const SL: Classes.TStrings; const Delim: Char;
  const AllowEmpty: Boolean = True): string;
  {Joins all strings in given string list together into single string separated
  by given delimiter. If AllowEmpty is true then any empty strings are included
  in output string, but are ignored if false.}

function ParseDelims(const TextLine: string; var StartPos: Integer;
  const Delims: string): string;
  {Returns the sub-string of TextLine that begins at StartPos and is terminated
  by one of the delimiting characters Delims or the end of the string. StartPos
  is updated to index of character after delimiter. Returns '' if there is no
  sub-string after StartPos.}

function SplitStr(const S: string; Delim: Char; out S1, S2: string): Boolean;
  {Splits the string S at the first occurence of delimiter character Delim and
  sets S1 to the sub-string before Delim and S2 to substring following Delim.
  If Delim is found in string True is returned, while if Delim is not in string
  False is returned, S1 is set to S and S2 is set to ''.}

procedure AddToRecentDocs(const FileName: string);
  {Adds given file to Recent Documents folder that appears on the Start menu.}

procedure ClearRecentDocs;
  {Clears the Recent Documents folder so that no recent documents appear on
  Start menu.}

function CreateShellLink(const LinkFileName, AssocFileName, Desc, WorkDir,
  Args, IconFileName: string; const IconIdx: Integer): Boolean;
  {Create a shell link named LinkFileName that is a shortcut to file
  AssocFileName with descriprion Desc. The shortcut activates its file in given
  Working Directory and passes given command line Args to AssocFileName. If an
  icon file and index offset are provided the required icon is used for the
  shortcut. Function returns true on success and false on error.}

function ExecAndWait(const CommandLine: string) : Boolean;
  {Executes the given command line and waits for the program started by the
  command line to exit. Returns true if the program returns a zero exit code
  and false if the program doesn't start or returns a non-zero error code.}

function ExecAssociatedApp(const FileName: string): Boolean;
  {Executes the application associated with the given file name. Returns true if
  application is started successfully and false if not.}

function ExploreFolder(const Folder: string): Boolean;
  {Starts Windows Explorer to explore given folder. Returns true if folder is
  valid and can be explored, or false otherwise.}

function FindAssociatedApp(const Doc: string): string;
  {Returns the fully specified path of the program associated with the given
  document file name. Requires ShellAPI. Returns empty string if no such
  associated application.}

function OpenFolder(const Folder: string): Boolean;
  {Opens given folder in Windows Explorer. Returns true if folder is valid and
  can be opened, or false otherwise.}

function ShowFindFilesDlg(const Folder: string): Boolean;
  {Displays the Windows find files dialog box ready for searching the given
  folder. Returns true if dialog is shown and false if can't be shown (e.g. if
  given folder is not valid).}

function CommonFilesFolder: string;
  {Returns directory used for common files.}

function GetCurrentVersionRegStr(const SubKey, ValName: string): string;
  {Gets given string value from given subkey of Windows current version registry
  key.}

function ProgramFilesFolder: string;
  {Returns directory used for program files.}

function SystemFolder: string;
  {Returns path to Windows system folder.}

function TempFolder: string;
  {Returns path to Windows temporary folder.}

function WindowsFolder: string;
  {Returns path to Windows folder.}


implementation

{ Implementation of public and private routines }

function WinFileTimeToDateTime(FT: Windows.TFileTime): TDateTime;
  {Converts Windows FILETIME to Delphi TDateTime. Raises exception if file time
  is not a valid value.}
var
  SysTime: Windows.TSystemTime; // stores date/time in system time format
begin
  // Convert file time to system time, raising exception on error
  SysUtils.Win32Check(Windows.FileTimeToSystemTime(FT, SysTime));
  // Convert system time to Delphi date time, raising excpetion on error
  Result := SysUtils.SystemTimeToDateTime(SysTime);
end;

function WinFileTimeToDOSFileTime(FT: Windows.TFileTime): Integer;
  {Converts a Windows FILETIME to a DOS file time. Raises exception if file time
  is not a valid value.}
begin
  SysUtils.Win32Check(
    Windows.FileTimeToDosDateTime(
      FT, SysUtils.LongRec(Result).Hi, SysUtils.LongRec(Result).Lo
    )
  );
end;

function WinFileTimeToStr(FT: Windows.TFileTime): string;
  {Converts a Windows FILETIME structure to a string. Raises exception if file
  time is not a valid value.}
begin
  Result := SysUtils.DateTimeToStr(WinFileTimeToDateTime(FT));
end;

procedure CopyFile(const Source, Dest: string);
  {Copies Source file to Dest, preserving modification date.}
var
  SourceStream, DestStream: Classes.TFileStream; // source and dest file streams
begin
  DestStream := nil;
  // Open source and dest file streams
  SourceStream := Classes.TFileStream.Create(
    Source, SysUtils.fmOpenRead or SysUtils.fmShareDenyWrite
  );
  try
    DestStream := Classes.TFileStream.Create(
      Dest, Classes.fmCreate or SysUtils.fmShareExclusive
    );
    // Copy file from source to dest
    DestStream.CopyFrom(SourceStream, SourceStream.Size);
    // Set dest file's modification date to same as source file
    SysUtils.FileSetDate(
      DestStream.Handle, SysUtils.FileGetDate(SourceStream.Handle)
    );
  finally
    // Close files
    DestStream.Free;
    SourceStream.Free;
  end;
end;

procedure CreateURLShortcut(const ShortcutFile, URL: string);
  {Creates a URL shortcut file with the given name for the given URL,
  overwriting any existing file. An exception is raised if file can't be
  created.}
var
  F: TextFile;  // text file
begin
  {$I+} // ensure file i/o raises exception on error
  // Open new file for writing (overwrites any existing file)
  AssignFile(F, ShortcutFile);
  Rewrite(F);
  try
    // Write file contents: this is simplest basic format of shortcut file
    WriteLn(F, '[InternetShortcut]');
    WriteLn(F, 'URL=', URL);
  finally
    // Close file
    CloseFile(F);
  end;
end;

function DeleteFileWithUndo(const FileName: string): Boolean;
  {Deletes given file and sends it to recycle bin. Returns true if file deleted
  successfully.}
var
  FOS: ShellAPI.TSHFileOpStruct;  // contains info about required file operation
begin
  // Set up structure that determines file operation
  FillChar(FOS, SizeOf(FOS), 0);
  with FOS do
  begin
    wFunc := ShellAPI.FO_DELETE;      // we're deleting
    pFrom := PChar(FileName + #0);    // this file (#0#0 terminated)
    fFlags := ShellAPI.FOF_ALLOWUNDO  // with facility to undo op
      or ShellAPI.FOF_NOCONFIRMATION  // and we don't want any dialogs
      or ShellAPI.FOF_SILENT;
  end;
  // Perform the operation
  Result := ShellAPI.SHFileOperation(FOS) = 0;
end;

function DirToPath(const Dir: string): string;
  {Return given directory with a trailing '\'.}
begin
  if (Dir <> '') and (Dir[Length(Dir)] <> '\') then
    Result := Dir + '\'
  else
    Result := Dir;
end;

function DOSToUnixPath(const PathName: string): string;
  {Converts a DOS path to a Unix path and returns it.}
begin
  Result := SysUtils.StringReplace(PathName, '\', '/', [SysUtils.rfReplaceAll]);
end;

function DriveTypeFromPath(const Path: string): LongWord;
  {Returns type of drive that contains the given (full) path.}
var
  Drive: string;  // the drive name
begin
  Drive := SysUtils.ExtractFileDrive(Path) + '\';
  Result := Windows.GetDriveType(PChar(Drive));
end;

function GetFileDate(const FName: string): Integer;
  {Returns modification date of given file encoded as integer.}
var
  FileH: Integer;   // file handle
begin
  // Open file
  FileH := SysUtils.FileOpen(FName, SysUtils.fmOpenRead);
  if FileH = -1 then
    // Couldn't open file - return -1 to indicate can't get date
    Result := -1
  else
  begin
    // File opened OK - record date and close file
    Result := SysUtils.FileGetDate(FileH);
    SysUtils.FileClose(FileH);
  end;
end;

function GetFixedFileVerInfo(const FileName: string;
  out FFI: Windows.TVSFixedFileInfo): Boolean;
  {Extracts fixed version information from a file. If file contains version
  information it is returned via FFI parameter and function returns true,
  otherwise false is returned and FFI is undefined.}
var
  VerInfoBuf: Pointer;    // points to memory storing version info
  VerInfoSize: Integer;   // size of version info memory
  Dummy: Windows.THandle; // unused parameter required by API function
  PFFI: Pointer;          // points to fixed file info
  FFISize: LongWord;      // size of file file info returned from API (unused)
begin
  // Assume failure: sets zero result
  FillChar(FFI, SizeOf(FFI), 0);
  Result := False;
  // Get size of version info: there is none if this is zero
  VerInfoSize := Windows.GetFileVersionInfoSize(PChar(FileName), Dummy);
  if VerInfoSize > 0 then
  begin
    // Allocate memory to store ver info
    GetMem(VerInfoBuf, VerInfoSize);
    try
      // Get the version info, filling buffer
      if Windows.GetFileVersionInfo(
        PChar(FileName), Dummy, VerInfoSize, VerInfoBuf
      ) then
      begin
        // Get a pointer to fixed file info
        if Windows.VerQueryValue(VerInfoBuf, '\', PFFI, FFISize) then
        begin
          // Got pointer OK: record file version
          FFI := Windows.PVSFixedFileInfo(PFFI)^;
          Result := True;
        end;
      end;
    finally
      // Dispose of ver info storage
      FreeMem(VerInfoBuf, VerInfoSize);
    end;
  end;
end;

function HasVerInfo(const FileName: string): Boolean;
  {Returns true if the given file contains version information and false if
  not.}
var
  Dummy: Windows.THandle; // dummy variable required by API function
begin
  // API function returns size of ver info: 0 if none
  Result := Windows.GetFileVersionInfoSize(PChar(FileName), Dummy) > 0;
end;

function IsDirectory(const DirName: string): Boolean;
  {Returns true if given name is a valid directory and false otherwise. DirName
  can be any file system name (with or without trailing path delimiter).}
var
  Attr: Integer;  // directory's file attributes
begin
  Attr := SysUtils.FileGetAttr(DirName);
  Result := (Attr <> -1)
    and (Attr and SysUtils.faDirectory = SysUtils.faDirectory);
end;

procedure SetFileDate(const FName: string; const ADate: Integer);
  {Sets modification date of given file to given integer coded value.}
var
  FileH: Integer;   // file handle
begin
  // Open file
  FileH := SysUtils.FileOpen(FName, SysUtils.fmOpenWrite);
  if FileH <> -1 then
  begin
    // File opened OK - set date and close file
    SysUtils.FileSetDate(FileH, ADate);
    SysUtils.FileClose(FileH);
  end;
end;

function ShortToLongPath(const FilePath: string): string;
  {Converts whole of given DOS style 8.3 path to long file path and returns it.
  If path can't be converted then '' is returned.}
var
  PrevPath: string;         // path before last file/dir in FilePath
  ExpandedName: string;     // long form of file name
  SR: SysUtils.TSearchRec;  // record used by file find functions
  Success: Integer;         // indicates success in finding a file
  // ---------------------------------------------------------------------------
  function CountPathDelims(const Name: string): Integer;
    {Counts path separators in given name}
  var
    Idx: Integer; // loops thru name string
  begin
    Result := 0;
    for Idx := 1 to Length(Name) do
      if SysUtils.IsPathDelimiter(Name, Idx) then
        Inc(Result);
  end;

  function IsServerName(const Name: string): Boolean;
    {Returns true if Names is in form \\Server\Share}
  begin
    Result := (SysUtils.AnsiPos('\\', Name) = 1)
      and (CountPathDelims(Name) = 3);
  end;
  // ---------------------------------------------------------------------------
begin
  // Check if we have a drive, server/share or root path, and exit if so
  // (we can't apply file search to any of these, so we return them unchanged
  if (FilePath = '')
    or (FilePath = '\')
    or ((Length(FilePath) = 2) and (FilePath[2] = ':'))
    or ((Length(FilePath) = 3) and (FilePath[2] = ':') and (FilePath[3] = '\'))
    or IsServerName(FilePath) then
  begin
    Result := FilePath;
    Exit;
  end;
  // Do a file search on file: this is used to expand name
  Success := SysUtils.FindFirst(FilePath, SysUtils.faAnyFile, SR);
  try
    if Success = 0 then
      ExpandedName := SR.FindData.cFileName
    else
      ExpandedName := '';
  finally
    SysUtils.FindClose(SR);
  end;
  // Check if there's any part of path we've not handled, and convert it if so
  PrevPath := SysUtils.ExtractFileDir(FilePath);
  if PrevPath <> '' then
  begin
    // We have unprocessed part of path: expand that
    Result := ShortToLongPath(PrevPath);
    // Appended currently expanded name to path
    if (Result <> '') and (Result[Length(Result)] <> '\') then
      Result := Result + '\';
    Result := Result + ExpandedName;
  end
  else
    // No earlier parts of path: just record expanded name
    Result := ExpandedName;
end;

function TempFileName(const Stub: string; const Create: Boolean): string;
  {Returns a unique temporary file name in temporary folder. File name includes
  first three characters of Stub followed by hexadecimal characters. If Create
  is true file is created. Returns empty string on failure.}
begin
  // Get temporary folder
  SetLength(Result, Windows.MAX_PATH);
  Windows.GetTempPath(Windows.MAX_PATH, PChar(Result));
  // Get unique temporary file name (it is created as side effect of this call)
  if Windows.GetTempFileName(
    PChar(Result), PChar(Stub), 0, PChar(Result)
  ) <> 0 then
  begin
    // Succeeded
    Result := PChar(Result);
    if not Create then
      // user doesn't want file creating: so we delete the file
      SysUtils.DeleteFile(Result);
  end
  else
    // Failed
    Result := '';
end;

function Touch(const FileName: string): Boolean;
  {Sets modification date of given file to current date and time. Returns true
  if date set successfully or false on error.}
var
  FileH: Integer; // handle of file
begin
  // Assume failure
  Result := False;
  // Try to open file: bail out if can't open
  FileH := SysUtils.FileOpen(
    FileName, SysUtils.fmOpenWrite or SysUtils.fmShareDenyWrite
  );
  if FileH = -1 then
    Exit;
  try
    // Set date to current date and time: return true if succeed
    if SysUtils.FileSetDate(
      FileH, SysUtils.DateTimeToFileDate(SysUtils.Now())
    ) = 0 then
      Result := True;
  finally
    // Close the file
    SysUtils.FileClose(FileH);
  end;
end;

function URLFromShortcut(const Shortcut: string): string;
  {Returns the URL referenced by the given URL shortcut file, or the empty
  string if the given file is not a shortcut file.}
var
  Ini: IniFiles.TIniFile; // object used to read shortcut file
begin
  // Return URL item from [InternetShortcut] section of shortcut file
  Ini := IniFiles.TIniFile.Create(Shortcut);
  try
    try
      Result := Ini.ReadString('InternetShortcut', 'URL', '');
    except;
      // We return '' on error
      Result := '';
    end;
  finally
    Ini.Free;
  end;
end;

function BrowseURL(const URL: string): Boolean;
  {Activates default browser or email client for given URL. Returns true if
  browser/email client is uccessfully launched and false if not. Raises
  exception if URL doesn't conform to a known valid protocol.}
begin
  if not IsValidURLProtocol(URL) then
    raise SysUtils.Exception.CreateFmt('"%s" is not a valid URL', [URL]);
  Result := ExecAssociatedApp(URL);
end;

function DownloadURLToFile(const URL, FileName: string): Boolean;
  {Downloads file at URL and stores in given file. Returns true if download
  succeeds and false on failure. A connection to the internet must be open for
  download to succeed.}
begin
  // URLDownloadFile returns true if URL exists even if file not created
  // hence we also check file has been created.
  Result := Windows.Succeeded(
    UrlMon.URLDownloadToFile(nil, PChar(URL), PChar(FileName), 0, nil)
  ) and SysUtils.FileExists(FileName);
end;

function IsValidURLProtocol(const URL: string): Boolean;
  {Checks if the given URL is valid per RFC1738. Returns true is valid and false
  if not.}
const
  CNumProtocols = 10;    // number of known protocols
  CProtocols: array[1..CNumProtocols] of string = (
    // Array of valid protocols - per RFC 1738
    'ftp://', 'http://', 'gopher://', 'mailto:', 'news:', 'nntp://',
    'telnet://', 'wais://', 'file://', 'prospero://'
  );
var
  I: Integer;   // loops thru known protocols
begin
  // Scan array of protocols checking for a match with start of given URL
  Result := False;
  for I := 1 to CNumProtocols do
    if Pos(CProtocols[I], SysUtils.LowerCase(URL)) <> 0 then
    begin
      Result := True;
      Break;
    end;
end;

function MakeSafeHTMLText(TheText: string): string;
  {Replaces any characters in the given text that are HTML-compatible with
  suitable escaped versions and returns modified string.}
var
  Idx: Integer; // loops thru the given text
begin
  Result := '';
  for Idx := 1 to Length(TheText) do
    case TheText[Idx] of
      '<':  // opens tags: replace with special char reference
        Result := Result + '&lt;';
      '>':  // closes tags: replace with special char reference
        Result := Result + '&gt;';
      '&':  // begins char references: replace with special char reference
        Result := Result + '&amp;';
      #0..#31, #127..#255:  // control and special chars: replace with encoding
        Result := Result + '&#' + SysUtils.IntToStr(Ord(TheText[Idx])) + ';';
      else  // compatible text: pass thru
        Result := Result + TheText[Idx];
    end;
end;

function URLDecode(const S: string): string;
  {Decodes the given encoded URL or URL query string. Raises exception if the
  encoded URL is badly formed.}
var
  Idx: Integer;   // loops thru chars in string
  Hex: string;    // string of hex characters
  Code: Integer;  // hex character code (-1 on error)
begin
  // Intialise result and string index
  Result := '';
  Idx := 1;
  // Loop thru string decoding each character
  while Idx <= Length(S) do
  begin
    case S[Idx] of
      '%':
      begin
        // % should be followed by two hex digits - exception otherwise
        if Idx <= Length(S) - 2 then
        begin
          // there are sufficient digits - try to decode hex digits
          Hex := S[Idx+1] + S[Idx+2];
          Code := SysUtils.StrToIntDef('$' + Hex, -1);
          Inc(Idx, 2);
        end
        else
          // insufficient digits - error
          Code := -1;
        // check for error and raise exception if found
        if Code = -1 then
          raise SysUtils.EConvertError.Create(
            'Invalid hex digit in URL'
          );
        // decoded OK - add character to result
        Result := Result + Chr(Code);
      end;
      '+':
        // + is decoded as a space
        Result := Result + ' '
      else
        // All other characters pass thru unchanged
        Result := Result + S[Idx];
    end;
    Inc(Idx);
  end;
end;

function URLEncode(const S: string): string;
  {URL encodes the given string, making it suitable for passing as part of a URL
  query.}
var
  Idx: Integer; // loops thru characters in string
begin
  Result := '';
  for Idx := 1 to Length(S) do
  begin
    case S[Idx] of
      'A'..'Z', 'a'..'z', '0'..'9', '-', '_', '.': Result := Result + S[Idx];
      ' ': Result := Result + '+';
      else Result := Result + '%' + SysUtils.IntToHex(Ord(S[Idx]), 2);
    end;
  end;
end;

function CompressWhiteSpace(const S: string): string;
  {Returns a copy of given string with all white space characters replaced by
  space characters and all sequences of white space replaced by a single space
  character.}
var
  Idx: Integer;       // loops thru all characters in string
  ResCount: Integer;  // counts number of characters in result string
  PRes: PChar;        // pointer to characters in result string
const
  // The white space characters we convert to spaces
  cWhiteSpace = [#9, #10, #11, #12, #13, ' '];
begin
  // Set length of result to length of source string and set pointer to it
  SetLength(Result, Length(S));
  PRes := PChar(Result);
  // Reset count of characters in result string
  ResCount := 0;
  // Loop thru characters of source string
  Idx := 1;
  while Idx <= Length(S) do
  begin
    if S[Idx] in cWhiteSpace then
    begin
      // Current char is white space: replace by space char and count it
      PRes^ := ' ';
      Inc(PRes);
      Inc(ResCount);
      // Skip past any following white space
      Inc(Idx);
      while S[Idx] in cWhiteSpace do
        Inc(Idx);
    end
    else
    begin
      // Current char is not white space: copy it literally and count it
      PRes^ := S[Idx];
      Inc(PRes);
      Inc(ResCount);
      Inc(Idx);
    end;
  end;
  // Reduce length of result string if it is shorter than source string
  if ResCount < Length(S) then
    SetLength(Result, ResCount);
end;

function CountDelims(const S, Delims: string): Integer;
  {Returns count of all occurences of any of the given delimiter characters in
  the string S.}
var
  Idx: Integer; //loops thru all characters in string
begin
  Result := 0;
  for Idx := 1 to Length(S) do
    if SysUtils.IsDelimiter(Delims, S, Idx) then
      Inc(Result);
end;

function ExplodeStr(S: string; const Delim: Char; const List: Classes.TStrings;
  const AllowEmpty: Boolean = True): Integer;
  {Splits the string S into a list of strings, separated by Delim, and returns
  the number of strings in the list. If AllowEmpty is true then any empty
  strings are added to the list, while they are ignored if AllowEmpty is
  false.}
var
  Item: string;       // current delimted text
  Remainder: string;  // remaining unconsumed part of string
begin
  // Clear the list
  List.Clear;
  // Check we have some entries in the string
  if S <> '' then
  begin
    // Repeatedly split string until we have no more entries
    while SplitStr(S, Delim, Item, Remainder) do
    begin
      // Add the current string, is required
      if (Item <> '') or AllowEmpty then
        List.Add(Item);
      // Go round again with remainder of string
      S := Remainder;
    end;
    // Add any terminal item
    if (Item <> '') or AllowEmpty then
      List.Add(Item);
  end;
  // Return number of items read
  Result := List.Count;
end;

function JoinStr(const SL: Classes.TStrings; const Delim: Char;
  const AllowEmpty: Boolean = True): string;
  {Joins all strings in given string list together into single string separated
  by given delimiter. If AllowEmpty is true then any empty strings are included
  in output string, but are ignored if false.}
var
  Idx: Integer; // loops thru all items in string list
begin
  Result := '';
  for Idx := 0 to Pred(SL.Count) do
  begin
    if (SL[Idx] <> '') or AllowEmpty then
      if Result = '' then
        Result := SL[Idx]
      else
        Result := Result + Delim + SL[Idx];
  end;
end;

function ParseDelims(const TextLine: string; var StartPos: Integer;
  const Delims: string): string;
  {Returns the sub-string of TextLine that begins at StartPos and is terminated
  by one of the delimiting characters Delims or the end of the string. StartPos
  is updated to index of character after delimiter. Returns '' if there is no
  sub-string after StartPos.}
var
  StringEnd: Integer;     // tracks end of current string being parsed out
begin
  // Find next non-delimiter char - this is where token starts
  while (StartPos <= Length(TextLine))
    and SysUtils.IsDelimiter(Delims, TextLine, StartPos) do
    Inc(StartPos);
  // Now find next delimiter - this is where token ends
  StringEnd := StartPos;
  while (StringEnd <= Length(TextLine))
    and not SysUtils.IsDelimiter(Delims, TextLine, StringEnd) do
    Inc(StringEnd);
  // Copy result out of string
  Result := Copy(TextLine, StartPos, StringEnd - StartPos);
  StartPos := StringEnd + 1;
end;

function SplitStr(const S: string; Delim: Char; out S1, S2: string): Boolean;
  {Splits the string S at the first occurence of delimiter character Delim and
  sets S1 to the sub-string before Delim and S2 to substring following Delim.
  If Delim is found in string True is returned, while if Delim is not in string
  False is returned, S1 is set to S and S2 is set to ''.}
var
  DelimPos: Integer;  // position of delimiter in source string
begin
  // Find position of first occurence of delimter in string
  DelimPos := SysUtils.AnsiPos(Delim, S);
  if DelimPos > 0 then
  begin
    // Delimiter found: do split and return True
    S1 := Copy(S, 1, DelimPos - 1);
    S2 := Copy(S, DelimPos + 1, MaxInt);
    Result := True;
  end
  else
  begin
    // Delimeter not found: return false and set S1 to whole string
    S1 := S;
    S2 := '';
    Result := False;
  end;
end;

procedure AddToRecentDocs(const FileName: string);
  {Adds given file to Recent Documents folder that appears on the Start menu.}
begin
  ShlObj.SHAddToRecentDocs(ShlObj.SHARD_PATH, PChar(FileName));
end;

procedure ClearRecentDocs;
  {Clears the Recent Documents folder so that no recent documents appear on
  Start menu.}
begin
  ShlObj.SHAddToRecentDocs(ShlObj.SHARD_PATH, nil);
end;

function CreateShellLink(const LinkFileName, AssocFileName, Desc, WorkDir,
  Args, IconFileName: string; const IconIdx: Integer): Boolean;
  {Create a shell link named LinkFileName that is a shortcut to file
  AssocFileName with descriprion Desc. The shortcut activates its file in given
  Working Directory and passes given command line Args to AssocFileName. If an
  icon file and index offset are provided the required icon is used for the
  shortcut. Function returns true on success and false on error.}
var
  SL: ShlObj.IShellLink;    // shell link object
  PF: ActiveX.IPersistFile; // persistant file interface to shell link object
begin
  // Assume failure
  Result := False;
  // Ensure COM is initialised
  ActiveX.CoInitialize(nil);
  try
    // Create shell link object
    if ActiveX.Succeeded(
      ActiveX.CoCreateInstance(
        ShlObj.CLSID_ShellLink,
        nil,
        ActiveX.CLSCTX_INPROC_SERVER,
        ShlObj.IShellLink, SL
      )
    ) then
    begin
      // Store required properties of shell link
      SL.SetPath(PChar(AssocFileName));
      SL.SetDescription(PChar(Desc));
      SL.SetWorkingDirectory(PChar(WorkDir));
      SL.SetArguments(PChar(Args));
      if (IconFileName <> '') and (IconIdx >= 0) then
        SL.SetIconLocation(PChar(IconFileName), IconIdx);
      // Create persistant file interface to shell link to save link file
      PF := SL as ActiveX.IPersistFile;
      Result := ActiveX.Succeeded(
        PF.Save(PWideChar(WideString(LinkFileName)), True)
      );
    end;
  finally
    // Finalize COM
    ActiveX.CoUninitialize;
  end;
end;

function ExecAndWait(const CommandLine: string) : Boolean;
  {Executes the given command line and waits for the program started by the
  command line to exit. Returns true if the program returns a zero exit code
  and false if the program doesn't start or returns a non-zero error code.}
var
  StartupInfo: Windows.TStartupInfo;        // start-up info passed to process
  ProcessInfo: Windows.TProcessInformation; // info about the process
  ProcessExitCode: Windows.DWord;           // process's exit code
begin
  // Set default error result
  Result := False;
  // Initialise startup info structure to 0, and record length
  FillChar(StartupInfo, SizeOf(StartupInfo), 0);
  StartupInfo.cb := SizeOf(StartupInfo);
  // Execute application commandline
  if Windows.CreateProcess(nil, PChar(CommandLine),
    nil, nil, False, 0, nil, nil,
    StartupInfo, ProcessInfo) then
  begin
    try
      // Now wait for application to complete
      if Windows.WaitForSingleObject(ProcessInfo.hProcess, INFINITE)
        = WAIT_OBJECT_0 then
        // It's completed - get its exit code
        if Windows.GetExitCodeProcess(ProcessInfo.hProcess,
          ProcessExitCode) then
          // Check exit code is zero => successful completion
          if ProcessExitCode = 0 then
            Result := True;
    finally
      // Tidy up
      Windows.CloseHandle(ProcessInfo.hProcess);
      Windows.CloseHandle(ProcessInfo.hThread);
    end;
  end;
end;

function ExecAssociatedApp(const FileName: string): Boolean;
  {Executes the application associated with the given file name. Returns true if
  application is started successfully and false if not.}
begin
  Result := ShellAPI.ShellExecute(
    0,
    nil,
    PChar(FileName),
    nil,
    nil,
    Windows.SW_SHOW
  ) > 32;
end;

function ExploreFolder(const Folder: string): Boolean;
  {Starts Windows Explorer to explore given folder. Returns true if folder is
  valid and can be explored, or false otherwise.}
begin
  if SysUtils.FileGetAttr(Folder) and faDirectory = faDirectory then
    // Folder is valid directory: try to explore it
    Result := ShellAPI.ShellExecute(
      0, 'explore', PChar(Folder), nil, nil, Windows.SW_SHOWNORMAL
    ) > 32
  else
    // Folder is not a directory: error
    Result := False;
end;

function FindAssociatedApp(const Doc: string): string;
  {Returns the fully specified path of the program associated with the given
  document file name. Requires ShellAPI. Returns empty string if no such
  associated application.}
var
  PExecFile: array[0..Windows.MAX_PATH] of Char; // buffer to hold exe name
begin
  // Win API call in ShellAPI
  if ShellAPI.FindExecutable(PChar(Doc), nil, PExecFile) < 32 then
    // No associated program found
    Result := ''
  else
    // Return program file name
    Result := PExecFile;
end;

function OpenFolder(const Folder: string): Boolean;
  {Opens given folder in Windows Explorer. Returns true if folder is valid and
  can be opened, or false otherwise.}
begin
  if SysUtils.FileGetAttr(Folder) and faDirectory = faDirectory then
    // Folder is valid directory: try to open it
    Result := ShellAPI.ShellExecute(
      0, 'open', PChar(Folder), nil, nil, Windows.SW_SHOWNORMAL
    ) > 32
  else
    // Folder is not a directory: error
    Result := False;
end;

function ShowFindFilesDlg(const Folder: string): Boolean;
  {Displays the Windows find files dialog box ready for searching the given
  folder. Returns true if dialog is shown and false if can't be shown (e.g. if
  given folder is not valid).}
begin
  Result := ShellAPI.ShellExecute(
    0, 'find', PChar(Folder), '', '', Windows.SW_SHOW
  ) > 32;
end;

function CommonFilesFolder: string;
  {Returns directory used for common files.}
begin
  Result := GetCurrentVersionRegStr('', 'CommonFilesDir');
end;

function GetCurrentVersionRegStr(const SubKey, ValName: string): string;
  {Gets given string value from given subkey of Windows current version registry
  key.}
var
  Reg: Registry.TRegistry; // registry access object
const
  cWdwCurrentVer = '\Software\Microsoft\Windows\CurrentVersion';
begin
  // Open registry at the required key
  Reg := Registry.TRegistry.Create;
  try
    Reg.RootKey := Windows.HKEY_LOCAL_MACHINE;
    if Reg.OpenKeyReadOnly(cWdwCurrentVer) then
      // Read path required
      Result := Reg.ReadString(ValName)
    else
      Result := '';
  finally
    Reg.Free;
  end;
end;

function ProgramFilesFolder: string;
  {Returns directory used for program files.}
begin
  Result := GetCurrentVersionRegStr('', 'ProgramFilesDir');
end;

function SystemFolder: string;
  {Returns path to Windows system folder.}
begin
  SetLength(Result, Windows.MAX_PATH);
  SetLength(
    Result, Windows.GetSystemDirectory(PChar(Result), Windows.MAX_PATH)
  );
end;

function TempFolder: string;
  {Returns path to Windows temporary folder.}
begin
  SetLength(Result, Windows.MAX_PATH);
  SetLength(
    Result, Windows.GetTempPath(Windows.MAX_PATH, PChar(Result))
  );
end;

function WindowsFolder: string;
  {Returns path to Windows folder.}
begin
  SetLength(Result, Windows.MAX_PATH);
  SetLength(
    Result, Windows.GetWindowsDirectory(PChar(Result), Windows.MAX_PATH)
  );
end;

end.

