{ ... }
  type
    TDrawStyle = (ds_Transparent, ds_NotDistinctly, dsNormal);

    MyTransparentRichEdit = class(TRichEdit)
    protected
      FDrawStyle: TDrawStyle;
      procedure CreateParams(var Params: TCreateParams); override;
      procedure CreateWnd; override;
      procedure SetDrawStyle(AValue: TDrawStyle);
    public
      constructor Create(AOwner: TComponent); override;
    published
      property DrawStyle: TDrawStyle read FDrawStyle write SetDrawStyle;
    end;

{ ... }


constructor MyTransparentRichEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FDrawStyle := dsNormal;
end;


procedure MyTransparentRichEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  if not (csDesigning in ComponentState) then
  begin
    Params.Style := Params.Style or WS_POPUP;
    Params.ExStyle := Params.ExStyle + WS_EX_LAYERED;
  end;
end;


procedure MyTransparentRichEdit.CreateWnd;
var
  XPoint: TPoint;
begin
  if not (csDesigning in ComponentState) then
  begin
    XPoint := TWinControl(Owner).ClientToScreen(POINT(Left, Top));
    Left := XPoint.X;
    Top := XPoint.Y;
  end;
  inherited CreateWnd;
  case FDrawStyle of
    ds_Transparent:
      SetLayeredWindowAttributes(Handle, ColorToRGB(Color), 255, LWA_COLORKEY);
    ds_NotDistinctly:
      SetLayeredWindowAttributes(Handle, 0, 150, LWA_ALPHA);
  end;
end;


procedure MyTransparentRichEdit.SetDrawStyle(AValue: TDrawStyle);
begin
  if FDrawStyle <> AValue then
  begin
    FDrawStyle := AValue;
    RecreateWnd;
  end;
end;
